<?php

namespace Drupal\navigation_blocks\Plugin\Block;

use Drupal\Core\Entity\ContentEntityInterface;

/**
 * Provides a 'EntityBackButtonBlock' block.
 *
 * @Block(
 *  id = "entity_back_button_block",
 *  admin_label = @Translation("Entity back button block"),
 * )
 */
class EntityBackButtonBlock extends RefererBackButtonBlock {

  /**
   * {@inheritdoc}
   * @throws \Drupal\Core\Entity\EntityMalformedException
   */
  public function build() {
    $build = parent::build();
    if (!empty($build)) {
      return $build;
    }

    if (strpos($this->currentRouteMatch->getRouteName(), '.canonical')) {
      return [];
    }

    $parameters = $this->currentRouteMatch->getCurrentRouteMatch()
      ->getParameters()
      ->all();
    foreach ($parameters as $parameter) {
      if (!$parameter instanceof ContentEntityInterface) {
        continue;
      }
      /** @var ContentEntityInterface $entity */
      $entity = $parameter;
      $link = $entity->toLink()->toRenderable();
      $this->addLinkAttributes($link);
      return $link;
    }

    return [];
  }

}
